QCPColorScale Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Functions | Signals | Protected Functions
QCPColorScale Class Reference

A color scale for use with color coding data such as QCPColorMap. More...

Inheritance diagram for QCPColorScale:

## Public Functions
| QCPColorScale (QCustomPlot *parentPlot)
QCPAxis * | axis () const
QCPAxis::AxisType | type () const
QCPRange | dataRange () const
QCPAxis::ScaleType | dataScaleType () const
QCPColorGradient | gradient () const
QString | label () const
int | barWidth () const
bool | rangeDrag () const
bool | rangeZoom () const
void | setType (QCPAxis::AxisType type)
Q_SLOT void | setDataRange (const QCPRange &dataRange)
Q_SLOT void | setDataScaleType (QCPAxis::ScaleType scaleType)
Q_SLOT void | setGradient (const QCPColorGradient &gradient)
void | setLabel (const QString &str)
void | setBarWidth (int width)
void | setRangeDrag (bool enabled)
void | setRangeZoom (bool enabled)
QList< QCPColorMap * > | colorMaps () const
void | rescaleDataRange (bool onlyVisibleMaps)
virtual void | update (UpdatePhase phase)
Public Functions inherited from QCPLayoutElement
| QCPLayoutElement (QCustomPlot *parentPlot=nullptr)
QCPLayout * | layout () const
QRect | rect () const
QRect | outerRect () const
QMargins | margins () const
QMargins | minimumMargins () const
QCP::MarginSides | autoMargins () const
QSize | minimumSize () const
QSize | maximumSize () const
SizeConstraintRect | sizeConstraintRect () const
QCPMarginGroup * | marginGroup (QCP::MarginSide side) const
QHash< QCP::MarginSide, QCPMarginGroup * > | marginGroups () const
void | setOuterRect (const QRect &rect)
void | setMargins (const QMargins &margins)
void | setMinimumMargins (const QMargins &margins)
void | setAutoMargins (QCP::MarginSides sides)
void | setMinimumSize (const QSize &size)
void | setMinimumSize (int width, int height)
void | setMaximumSize (const QSize &size)
void | setMaximumSize (int width, int height)
void | setSizeConstraintRect (SizeConstraintRect constraintRect)
void | setMarginGroup (QCP::MarginSides sides, QCPMarginGroup *group)
virtual QSize | minimumOuterSizeHint () const
virtual QSize | maximumOuterSizeHint () const
virtual QList< QCPLayoutElement * > | elements (bool recursive) const
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=nullptr) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=nullptr)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Signals
void | dataRangeChanged (const QCPRange &newRange)
void | dataScaleTypeChanged (QCPAxis::ScaleType scaleType)
void | gradientChanged (const QCPColorGradient &newGradient)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)

## Protected Functions
virtual void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | mousePressEvent (QMouseEvent *event, const QVariant &details)
virtual void | mouseMoveEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | mouseReleaseEvent (QMouseEvent *event, const QPointF &startPos)
virtual void | wheelEvent (QWheelEvent *event)
Protected Functions inherited from QCPLayoutElement
virtual int | calculateAutoMargin (QCP::MarginSide side)
virtual void | layoutChanged ()
virtual void | draw (QCPPainter *painter)
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
Protected Functions inherited from QCPLayerable
virtual QCP::Interaction | selectionCategory () const
virtual QRect | clipRect () const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
virtual void | mouseDoubleClickEvent (QMouseEvent *event, const QVariant &details)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Public Types inherited from QCPLayoutElement
enum | UpdatePhase
enum | SizeConstraintRect

## Detailed Description

A color scale for use with color coding data such as QCPColorMap.

This layout element can be placed on the plot to correlate a color gradient with data values. It is usually used in combination with one or multiple QCPColorMaps.

The color scale can be either horizontal or vertical, as shown in the image above. The orientation and the side where the numbers appear is controlled with setType.

Use QCPColorMap::setColorScale to connect a color map with a color scale. Once they are connected, they share their gradient, data range and data scale type (setGradient, setDataRange, setDataScaleType). Multiple color maps may be associated with a single color scale, to make them all synchronize these properties.

To have finer control over the number display and axis behaviour, you can directly access the axis. See the documentation of QCPAxis for details about configuring axes. For example, if you want to change the number of automatically generated ticks, call

colorScale->axis()->ticker()->setTickCount(3);

Placing a color scale next to the main axis rect works like with any other layout element:

QCPColorScale *colorScale = new QCPColorScale(customPlot);
customPlot->plotLayout()->addElement(0, 1, colorScale);
colorScale->setLabel("Some Label Text");

In this case we have placed it to the right of the default axis rect, so it wasn't necessary to call setType, since QCPAxis::atRight is already the default. The text next to the color scale can be set with setLabel.

For optimum appearance (like in the image above), it may be desirable to line up the axis rect and the borders of the color scale. Use a QCPMarginGroup to achieve this:

QCPMarginGroup *group = new QCPMarginGroup(customPlot);
colorScale->setMarginGroup(QCP::msTop|QCP::msBottom, group);
customPlot->axisRect()->setMarginGroup(QCP::msTop|QCP::msBottom, group);

Color scales are initialized with a non-zero minimum top and bottom margin (setMinimumMargins), because vertical color scales are most common and the minimum top/bottom margin makes sure it keeps some distance to the top/bottom widget border. So if you change to a horizontal color scale by setting setType to QCPAxis::atBottom or QCPAxis::atTop, you might want to also change the minimum margins accordingly, e.g. setMinimumMargins(QMargins(6, 0, 6, 0)).

## Constructor & Destructor Documentation

## ◆ QCPColorScale()

QCPColorScale::QCPColorScale | ( | QCustomPlot * | parentPlot | ) |
| explicit

Constructs a new QCPColorScale.

## Member Function Documentation

## ◆ axis()

QCPAxis * QCPColorScale::axis | ( |  | ) | const
| inline

Returns the internal QCPAxis instance of this color scale. You can access it to alter the appearance and behaviour of the axis. QCPColorScale duplicates some properties in its interface for convenience. Those are setDataRange (QCPAxis::setRange), setDataScaleType (QCPAxis::setScaleType), and the method setLabel (QCPAxis::setLabel). As they each are connected, it does not matter whether you use the method on the QCPColorScale or on its QCPAxis.

If the type of the color scale is changed with setType, the axis returned by this method will change, too, to either the left, right, bottom or top axis, depending on which type was set.

## ◆ setType()

void QCPColorScale::setType | ( | QCPAxis::AxisType | type | ) |

Sets at which side of the color scale the axis is placed, and thus also its orientation.

Note that after setting type to a different value, the axis returned by axis() will be a different one. The new axis will adopt the following properties from the previous axis: The range, scale type, label and ticker (the latter will be shared and not copied).

## ◆ setDataRange()

void QCPColorScale::setDataRange | ( | const QCPRange & | dataRange | ) |

Sets the range spanned by the color gradient and that is shown by the axis in the color scale.

It is equivalent to calling QCPColorMap::setDataRange on any of the connected color maps. It is also equivalent to directly accessing the axis and setting its range with QCPAxis::setRange.

See also
  setDataScaleType, setGradient, rescaleDataRange

## ◆ setDataScaleType()

void QCPColorScale::setDataScaleType | ( | QCPAxis::ScaleType | scaleType | ) |

Sets the scale type of the color scale, i.e. whether values are associated with colors linearly or logarithmically.

It is equivalent to calling QCPColorMap::setDataScaleType on any of the connected color maps. It is also equivalent to directly accessing the axis and setting its scale type with QCPAxis::setScaleType.

Note that this method controls the coordinate transformation. For logarithmic scales, you will likely also want to use a logarithmic tick spacing and labeling, which can be achieved by setting the color scale's axis ticker to an instance of QCPAxisTickerLog :

colorScale->setDataScaleType(QCPAxis::stLogarithmic);
colorScale->axis()->setTicker(QSharedPointer<QCPAxisTickerLog>(new QCPAxisTickerLog));

See the documentation of QCPAxisTickerLog about the details of logarithmic axis tick creation.

See also
  setDataRange, setGradient

## ◆ setGradient()

void QCPColorScale::setGradient | ( | const QCPColorGradient & | gradient | ) |

Sets the color gradient that will be used to represent data values.

It is equivalent to calling QCPColorMap::setGradient on any of the connected color maps.

See also
  setDataRange, setDataScaleType

## ◆ setLabel()

void QCPColorScale::setLabel | ( | const QString & | str | ) |

Sets the axis label of the color scale. This is equivalent to calling QCPAxis::setLabel on the internal axis.

## ◆ setBarWidth()

void QCPColorScale::setBarWidth | ( | int | width | ) |

Sets the width (or height, for horizontal color scales) the bar where the gradient is displayed will have.

## ◆ setRangeDrag()

void QCPColorScale::setRangeDrag | ( | bool | enabled | ) |

Sets whether the user can drag the data range (setDataRange).

Note that QCP::iRangeDrag must be in the QCustomPlot's interactions (QCustomPlot::setInteractions) to allow range dragging.

## ◆ setRangeZoom()

void QCPColorScale::setRangeZoom | ( | bool | enabled | ) |

Sets whether the user can zoom the data range (setDataRange) by scrolling the mouse wheel.

Note that QCP::iRangeZoom must be in the QCustomPlot's interactions (QCustomPlot::setInteractions) to allow range dragging.

## ◆ colorMaps()

QList< QCPColorMap * > QCPColorScale::colorMaps | ( |  | ) | const

Returns a list of all the color maps associated with this color scale.

## ◆ rescaleDataRange()

void QCPColorScale::rescaleDataRange | ( | bool | onlyVisibleMaps | ) |

Changes the data range such that all color maps associated with this color scale are fully mapped to the gradient in the data dimension.

See also
  setDataRange

## ◆ update()

void QCPColorScale::update | ( | UpdatePhase | phase | ) |
| virtual

Updates the layout element and sub-elements. This function is automatically called before every replot by the parent layout element. It is called multiple times, once for every UpdatePhase. The phases are run through in the order of the enum values. For details about what happens at the different phases, see the documentation of UpdatePhase.

Layout elements that have child elements should call the update method of their child elements, and pass the current phase unchanged.

The default implementation executes the automatic margin mechanism in the upMargins phase. Subclasses should make sure to call the base class implementation.

Reimplemented from QCPLayoutElement.

## ◆ dataRangeChanged

void QCPColorScale::dataRangeChanged | ( | const QCPRange & | newRange | ) |
| signal

This signal is emitted when the data range changes.

See also
  setDataRange

## ◆ dataScaleTypeChanged

void QCPColorScale::dataScaleTypeChanged | ( | QCPAxis::ScaleType | scaleType | ) |
| signal

This signal is emitted when the data scale type changes.

See also
  setDataScaleType

## ◆ gradientChanged

void QCPColorScale::gradientChanged | ( | const QCPColorGradient & | newGradient | ) |
| signal

This signal is emitted when the gradient changes.

See also
  setGradient

## ◆ applyDefaultAntialiasingHint()

void QCPColorScale::applyDefaultAntialiasingHint | ( | QCPPainter * | painter | ) | const
| protectedvirtual

This function applies the default antialiasing setting to the specified painter, using the function applyAntialiasingHint. It is the antialiasing state the painter is put in, when draw is called on the layerable. If the layerable has multiple entities whose antialiasing setting may be specified individually, this function should set the antialiasing state of the most prominent entity. In this case however, the draw function usually calls the specialized versions of this function before drawing each entity, effectively overriding the setting of the default antialiasing hint.

First example: QCPGraph has multiple entities that have an antialiasing setting: The graph line, fills and scatters. Those can be configured via QCPGraph::setAntialiased, QCPGraph::setAntialiasedFill and QCPGraph::setAntialiasedScatters. Consequently, there isn't only the QCPGraph::applyDefaultAntialiasingHint function (which corresponds to the graph line's antialiasing), but specialized ones like QCPGraph::applyFillAntialiasingHint and QCPGraph::applyScattersAntialiasingHint. So before drawing one of those entities, QCPGraph::draw calls the respective specialized applyAntialiasingHint function.

Second example: QCPItemLine consists only of a line so there is only one antialiasing setting which can be controlled with QCPItemLine::setAntialiased. (This function is inherited by all layerables. The specialized functions, as seen on QCPGraph, must be added explicitly to the respective layerable subclass.) Consequently it only has the normal QCPItemLine::applyDefaultAntialiasingHint. The QCPItemLine::draw function doesn't need to care about setting any antialiasing states, because the default antialiasing hint is already set on the painter when the draw function is called, and that's the state it wants to draw the line with.

Reimplemented from QCPLayoutElement.

## ◆ mousePressEvent()

void QCPColorScale::mousePressEvent | ( | QMouseEvent * | event,
|  | const QVariant & | details )
| protectedvirtual

This event gets called when the user presses a mouse button while the cursor is over the layerable. Whether a cursor is over the layerable is decided by a preceding call to selectTest.

The current pixel position of the cursor on the QCustomPlot widget is accessible via `event->pos()`. The parameter details contains layerable-specific details about the hit, which were generated in the previous call to selectTest. For example, One-dimensional plottables like QCPGraph or QCPBars convey the clicked data point in the details parameter, as QCPDataSelection packed as QVariant. Multi-part objects convey the specific `SelectablePart` that was hit (e.g. QCPAxis::SelectablePart in the case of axes).

QCustomPlot uses an event propagation system that works the same as Qt's system. If your layerable doesn't reimplement the mousePressEvent or explicitly calls `event->ignore()` in its reimplementation, the event will be propagated to the next layerable in the stacking order.

Once a layerable has accepted the mousePressEvent, it is considered the mouse grabber and will receive all following calls to mouseMoveEvent or mouseReleaseEvent for this mouse interaction (a "mouse interaction" in this context ends with the release).

The default implementation does nothing except explicitly ignoring the event with `event->ignore()`.

See also
  mouseMoveEvent, mouseReleaseEvent, mouseDoubleClickEvent, wheelEvent

Reimplemented from QCPLayerable.

## ◆ mouseMoveEvent()

void QCPColorScale::mouseMoveEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos )
| protectedvirtual

This event gets called when the user moves the mouse while holding a mouse button, after this layerable has become the mouse grabber by accepting the preceding mousePressEvent.

The current pixel position of the cursor on the QCustomPlot widget is accessible via `event->pos()`. The parameter startPos indicates the position where the initial mousePressEvent occurred, that started the mouse interaction.

The default implementation does nothing.

See also
  mousePressEvent, mouseReleaseEvent, mouseDoubleClickEvent, wheelEvent

Reimplemented from QCPLayerable.

## ◆ mouseReleaseEvent()

void QCPColorScale::mouseReleaseEvent | ( | QMouseEvent * | event,
|  | const QPointF & | startPos )
| protectedvirtual

This event gets called when the user releases the mouse button, after this layerable has become the mouse grabber by accepting the preceding mousePressEvent.

The current pixel position of the cursor on the QCustomPlot widget is accessible via `event->pos()`. The parameter startPos indicates the position where the initial mousePressEvent occurred, that started the mouse interaction.

The default implementation does nothing.

See also
  mousePressEvent, mouseMoveEvent, mouseDoubleClickEvent, wheelEvent

Reimplemented from QCPLayerable.

## ◆ wheelEvent()

void QCPColorScale::wheelEvent | ( | QWheelEvent * | event | ) |
| protectedvirtual

This event gets called when the user turns the mouse scroll wheel while the cursor is over the layerable. Whether a cursor is over the layerable is decided by a preceding call to selectTest.

The current pixel position of the cursor on the QCustomPlot widget is accessible via `event->pos()`.

The `event->angleDelta()` indicates how far the mouse wheel was turned, which is usually +/- 120 for single rotation steps. However, if the mouse wheel is turned rapidly, multiple steps may accumulate to one event, making the delta larger. On the other hand, if the wheel has very smooth steps or none at all, the delta may be smaller.

The default implementation does nothing.

See also
  mousePressEvent, mouseMoveEvent, mouseReleaseEvent, mouseDoubleClickEvent

Reimplemented from QCPLayerable.

The documentation for this class was generated from the following files:

- src/layoutelements/layoutelement-colorscale.h
- src/layoutelements/layoutelement-colorscale.cpp